﻿'Programed by NAS6


Public Class MyQueue(Of T As {IComparable, ICloneable})
    Implements ICloneable

    Public buf() As T               'バンク
    Public Count As Integer = 0     'バンク数

    '排他的バンク末尾追加
    Public Sub XEnqueue(ByVal pnt As T)
        Dim i As Integer
        Dim j As Integer
        If Count = 0 Then
            i = Count
            ReDim Preserve buf(i)
            buf(i) = pnt.Clone()
            Count += 1
            Exit Sub
        End If
        i = 0
        For j = 0 To Count - 1
            If pnt.Equals(buf(j)) Then
                i = 1
                Exit For
            End If
        Next
        If i = 0 Then
            i = Count
            ReDim Preserve buf(i)
            buf(i) = pnt.Clone()
            Count += 1
        End If
    End Sub

    'バンク末尾追加
    Public Sub Enqueue(ByVal pnt As T)
        Dim i As Integer
        i = Count
        ReDim Preserve buf(i)
        buf(i) = pnt.Clone()
        Count += 1
    End Sub

    'バンク末尾削除
    Public Function Dequeue() As T
        Dim i As Integer
        i = Count - 1
        Dequeue = buf(i).Clone()
        ReDim Preserve buf(i - 1)
        Count = i
    End Function

    '解放
    Public Sub Clear()
        ReDim buf(0)
        Count = 0
    End Sub

    'バンク削除
    Public Sub Remove(ByVal a As Integer)
        Dim i As Integer
        If a < Count Then
            For i = a To Count - 2
                buf(i) = buf(i + 1).Clone()
            Next
            ReDim Preserve buf(Count - 2)
            Count = Count - 1
        End If
    End Sub

    'バンク削除
    Public Sub Remove(ByVal a As T)
        Remove(IndexOf(a))
    End Sub

    'バンク挿入
    Public Sub Insert(ByVal a As T, ByVal b As Integer)
        Dim i As Integer
        Dim j As Integer
        i = Count
        ReDim Preserve buf(i)
        For j = i - 1 To b Step -1
            buf(j + 1) = buf(j).Clone()
        Next
        buf(b) = a.Clone()
        Count += 1
    End Sub

    'バンク検索
    Public Function IndexOf(ByVal a As T)
        IndexOf = -1
        Dim i As Integer
        Dim j As Integer = 0
        Dim b As T
        If 0 < Count Then
            For i = 0 To Count - 1
                b = buf(i).Clone()
                If a.Equals(b) Then
                    j = 1
                    Exit For
                End If
            Next
            If Not j = 0 Then
                IndexOf = i
            End If
        End If
    End Function

    'クローン
    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New MyQueue(Of T)
        If 0 < Me.Count Then
            ret.buf = Me.buf.Clone()
        End If
        ret.Count = Me.Count
        Clone = ret
    End Function
End Class
